'use strict';

var _sigma = require('./sigma');

var _sigma2 = _interopRequireDefault(_sigma);

var _renderer = require('./renderer');

var _renderer2 = _interopRequireDefault(_renderer);

var _camera = require('./camera');

var _camera2 = _interopRequireDefault(_camera);

var _quadtree = require('./quadtree');

var _quadtree2 = _interopRequireDefault(_quadtree);

var _mouse = require('./captors/mouse');

var _mouse2 = _interopRequireDefault(_mouse);

var _webgl = require('./renderers/webgl');

var _webgl2 = _interopRequireDefault(_webgl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Sigma.js Library Endpoint
 * ==========================
 *
 * The library endpoint.
 */
var library = {
  Sigma: _sigma2.default,
  Renderer: _renderer2.default,
  Camera: _camera2.default,
  QuadTree: _quadtree2.default,
  MouseCaptor: _mouse2.default,
  WebGLRenderer: _webgl2.default
};

for (var k in library) {
  _sigma2.default[k] = library[k];
}module.exports = _sigma2.default;